use std::cmp::Ordering;

use ::task_state::TaskState;



pub trait Task: Send + Sync
{
   fn get_name(&self) -> &str;
   fn get_state(&self) -> TaskState;

   fn process(&mut self);
}



impl PartialEq for Task
{
   fn eq(&self, other: &Self) -> bool
   {
      self.get_name().to_string().eq(&other.get_name().to_string())
   }
}

impl Eq for Task
{
}

impl PartialOrd for Task
{
   fn partial_cmp(&self, other: &Self) -> Option<Ordering>
   {
      Some(self.cmp(other))
   }
}

impl Ord for Task
{
   fn cmp(&self, other: &Self) -> Ordering
   {
      self.get_name().to_string().cmp(&other.get_name().to_string())
   }
}
