use ::task::Task;
use ::taskable::Taskable;
use ::task_state::TaskState;



///
pub struct TaskContainer<T>
{
   ///
   pub state: TaskState,

   ///
   pub task: T
}



impl<T> TaskContainer<T> where T: Taskable
{
   ///
   pub fn new(task: T) -> TaskContainer<T>
   {
      TaskContainer
      {
         state: TaskState::Starting,
         task: task
      }
   }
}

impl<T> Task for TaskContainer<T> where T: Taskable
{
   ///
   fn get_name(&self) -> &str
   {
      self.task.get_name()
   }

   ///
   fn get_state(&self) -> TaskState
   {
      self.state
   }

   ///
   fn process(&mut self)
   {
      self.state = TaskState::Processing;
      println!("Processing task.");
      self.state = TaskState::Finished;
   }
}
